/* tmnr1r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

int main(void)
{
    /* Initialized data */
    static float up[4] = { 1e-6f,1e-7f,.1f,10.f };
    static float rm[33] = { 1200.f };
    static float ge[2] = { 1e-9f,1e-9f };
    static float xe[2] = { 1e-11f,1e-11f };
    static float x[2] = { -1.2f,1.f };
    static float fe = 1e-11f;

    /* System generated locals */
    float r__1;

    /* Local variables */
    extern int grad_c(), func_c();
    extern int mnr1r_c(float *, float *, int *, int *, U_fp, float *,
                       float *, U_fp, float *, float *, float *, float *,
                       int *);
    static float f, g[2];
    static int n, w, i0[2];

    n = 2;
    mnr1r_c(x, xe, i0, &n, (U_fp)func_c, &f, &fe, (U_fp)grad_c, g, ge, up,
            rm, &w);

    x[0] = (r__1 = 1.f - x[0], abs(r__1));
    x[1] = (r__1 = 1.f - x[1], abs(r__1));
    printf("\n %5i \n", w);
    printf("\n %12.5e %12.5e \n", x[0], x[1]);
    printf("\n %12.5e \n", f);
    printf("\n %12.5e %12.5e \n", g[0], g[1]);
    printf("\n %12.4e %12.4e %12.4e \n", rm[0], rm[1], rm[2]);
    return 0;
} /* main */

int func_c(float *x, float *f, float *fe)
{
    /* System generated locals */
    float r__1, r__2, r__3;

    /* Parameter adjustments */
    --x;

    /* Function Body */
/* Computing 2nd power */
    r__1 = x[1] - 1.f;
/* Computing 2nd power */
    r__3 = x[1];
/* Computing 2nd power */
    r__2 = x[2] - r__3 * r__3;
    *f = r__1 * r__1 + r__2 * r__2 * 100.f;
    return 0;
} /* func_c */

int grad_c(float *x, float *g, float *ge, int *i0)
{
    /* System generated locals */
    float r__1;

    /* Parameter adjustments */
    --g;
    --x;

    /* Function Body */
/* Computing 3rd power */
    r__1 = x[1];
    g[1] = (r__1 * (r__1 * r__1) * 200.f + x[1] - x[1] * 200.f * x[2] -
             1.f) * 2;
/* Computing 2nd power */
    r__1 = x[1];
    g[2] = (x[2] - r__1 * r__1) * 200.f;
    return 0;
} /* grad_c */
